



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>编写高效的js/jQuery代码 :rocket:</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">编写高效的js/jQuery代码 :rocket:</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:32:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>讨论jQuery和javascript性能的文章并不罕见。然而，本文我计划总结一些速度方面的技巧和我本人的一些建议，来提升你的jQuery和javascript代码。好的代码会带来速度的提升。快速渲染和响应意味着更好的用户体验。</p>
<p>首先，在脑子里牢牢记住jQuery就是javascript。这意味着我们应该采取相同的编码惯例,风格指南和最佳实践。</p>
<p>首先，如果你是一个javascript新手，我建议您阅读 《给JavaScript初学者的24条最佳实践》<a href="http://youngsterxyf.github.io/2013/03/11/js-best-practices-for-beginners/" rel="external nofollow noreferrer">http://youngsterxyf.github.io/2013/03/11/js-best-practices-for-beginners/</a>&nbsp;,这是一篇高质量的javascript教程，接触jQuery之前最好先阅读。</p>
<hr />
<h1>先来一个例子吧</h1>
<p>美刀是个很重的函数，尽量其缓存结果</p>
<pre class="prettyprint linenums"><code>var $merchantPage = $(".merchant_page");<br />
var $cartPage = $(".cart_page");<br />
var $shade = $("#shade");<br />
$("#check_order").on("click", function() {<br />
    $merchantPage.hide();<br />
    $cartPage.show();<br />
});

$(".continue").on("click", function() {<br />
    $merchantPage.show();<br />
    $cartPage.hide();<br />
});

$(".close").on("click", function() {<br />
    $shade.hide();<br />
});</code></pre>
<p>代码要有语义，比如很明显例子里有类似切换页面的逻辑，有个名字会让代码可读性提高很多</p>
<pre class="prettyprint linenums"><code>var $merchantPage = $(".merchant_page");<br />
var $cartPage = $(".cart_page");<br />
var $shade = $("#shade");<br />
$("#check_order").on("click", showCart);

$(".continue").on("click", showMerchant);

$(".close").on("click", closePage);

function closePage() {<br />
    $shade.hide();<br />
}<br />
function showCart() {<br />
    $merchantPage.hide();<br />
    $cartPage.show();<br />
}<br />
function showMerchant() {<br />
    $merchantPage.show();<br />
    $cartPage.hide();<br />
}</code></pre>
<p>最后dom有个范围，有个闭包，有个chain，再加一行点睛的注释，代码就非常漂亮，主次分明了</p>
<pre class="prettyprint linenums"><code>//商品购买模块<br />
(function($view) {<br />
    var $merchantPage = $view.find(".merchant_page");<br />
    var $cartPage = $view.find(".cart_page");<br />
    var $shade = $view.find("#shade");

    $view<br />
        .on("click", "#check_order", showCart)<br />
        .on("click", ".continue", showMerchant)<br />
        .on("click", ".close", closePage)<br />
    ;

    function closePage() {<br />
        $shade.hide();<br />
    }

    function showCart() {<br />
        $merchantPage.hide();<br />
        $cartPage.show();<br />
    }

    function showMerchant() {<br />
        $merchantPage.show();<br />
        $cartPage.hide();<br />
    }

})($(document.body))</code></pre>
<hr />
<p>当你准备使用jQuery,我强烈建议你遵循下面这些指南:</p>
<h1>缓存变量</h1>
<p>DOM遍历是昂贵的，所以尽量将会重用的元素缓存。</p>
<pre class="prettyprint linenums"><code>// 糟糕

h = $('#element').height();<br />
$('#element').css('height',h-20);

// 建议

$element = $('#element');<br />
h = $element.height();<br />
$element.css('height',h-20);</code></pre>
<h1>避免全局变量</h1>
<p>jQuery与javascript一样，一般来说,最好确保你的变量在函数作用域内。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$element = $('#element');<br />
h = $element.height();<br />
$element.css('height',h-20);

// 建议

var $element = $('#element');<br />
var h = $element.height();<br />
$element.css('height',h-20);</code></pre>
<h1>使用匈牙利命名法</h1>
<p>在变量前加$前缀，便于识别出jQuery对象。</p>
<pre class="prettyprint linenums"><code>// 糟糕

var first = $('#first');<br />
var second = $('#second');<br />
var value = $first.val();

// 建议 - 在jQuery对象前加$前缀

var $first = $('#first');<br />
var $second = $('#second'),<br />
var value = $first.val();</code></pre>
<h1>使用 Var 链（单 Var 模式）</h1>
<p>将多条var语句合并为一条语句，我建议将未赋值的变量放到后面。</p>
<pre class="prettyprint linenums"><code>var<br />
  $first = $('#first'),<br />
  $second = $('#second'),<br />
  value = $first.val(),<br />
  k = 3,<br />
  cookiestring = 'SOMECOOKIESPLEASE',<br />
  i,<br />
  j,<br />
  myArray = {};</code></pre>
<h1>请使用&rsquo;On&rsquo;</h1>
<p>在新版jQuery中，更短的 on(&ldquo;click&rdquo;) 用来取代类似 click() 这样的函数。在之前的版本中 on() 就是 bind()。自从jQuery 1.7版本后，on() 附加事件处理程序的首选方法。然而，出于一致性考虑，你可以简单的全部使用 on()方法。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$first.click(function(){<br />
    $first.css('border','1px solid red');<br />
    $first.css('color','blue');<br />
});

$first.hover(function(){<br />
    $first.css('border','1px solid red');<br />
})

// 建议<br />
$first.on('click',function(){<br />
    $first.css('border','1px solid red');<br />
    $first.css('color','blue');<br />
})

$first.on('hover',function(){<br />
    $first.css('border','1px solid red');<br />
})</code></pre>
<h1>精简javascript</h1>
<p>一般来说,最好尽可能合并函数。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$first.click(function(){<br />
    $first.css('border','1px solid red');<br />
    $first.css('color','blue');<br />
});

// 建议

$first.on('click',function(){<br />
    $first.css({<br />
        'border':'1px solid red',<br />
        'color':'blue'<br />
    });<br />
});</code></pre>
<h1>链式操作</h1>
<p>jQuery实现方法的链式操作是非常容易的。下面利用这一点。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$second.html(value);<br />
$second.on('click',function(){<br />
    alert('hello everybody');<br />
});<br />
$second.fadeIn('slow');<br />
$second.animate({height:'120px'},500);

// 建议

$second.html(value);<br />
$second.on('click',function(){<br />
    alert('hello everybody');<br />
}).fadeIn('slow').animate({height:'120px'},500);</code></pre>
<h1>维持代码的可读性</h1>
<p>伴随着精简代码和使用链式的同时，可能带来代码的难以阅读。添加缩紧和换行能起到很好的效果。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$second.html(value);<br />
$second.on('click',function(){<br />
    alert('hello everybody');<br />
}).fadeIn('slow').animate({height:'120px'},500);

// 建议

$second.html(value);<br />
$second<br />
    .on('click',function(){ alert('hello everybody');})<br />
    .fadeIn('slow')<br />
    .animate({height:'120px'},500);</code></pre>
<h1>选择短路求值</h1>
<p>短路求值是一个从左到右求值的表达式，用 &amp;&amp;（逻辑与）或（逻辑或）操作符。</p>
<pre class="prettyprint linenums"><code>// 糟糕

function initVar($myVar) {<br />
    if(!$myVar) {<br />
        $myVar = $('#selector');<br />
    }<br />
}

// 建议

function initVar($myVar) {<br />
    $myVar = $myVar || $('#selector');<br />
}</code></pre>
<p>选择捷径<br />精简代码的其中一种方式是利用编码捷径。</p>
<pre class="prettyprint linenums"><code>// 糟糕

if(collection.length &gt; 0){..}

// 建议

if(collection.length){..}</code></pre>
<h1>繁重的操作中分离元素</h1>
<p>如果你打算对DOM元素做大量操作（连续设置多个属性或css样式），建议首先分离元素然后在添加。</p>
<pre class="prettyprint linenums"><code>// 糟糕

var<br />
    $container = $("#container"),<br />
    $containerLi = $("#container li"),<br />
    $element = null;

$element = $containerLi.first();<br />
//... 许多复杂的操作

// better

var<br />
    $container = $("#container"),<br />
    $containerLi = $container.find("li"),<br />
    $element = null;

$element = $containerLi.first().detach();<br />
//... 许多复杂的操作

$container.append($element);</code></pre>
<h1>熟记技巧</h1>
<p>你可能对使用jQuery中的方法缺少经验,一定要查看的文档，可能会有一个更好或更快的方法来使用它。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$('#id').data(key,value);

// 建议 (高效)

$.data('#id',key,value);</code></pre>
<h1>使用子查询缓存的父元素</h1>
<p>正如前面所提到的，DOM遍历是一项昂贵的操作。典型做法是缓存父元素并在选择子元素时重用这些缓存元素。</p>
<pre class="prettyprint linenums"><code>// 糟糕

var<br />
    $container = $('#container'),<br />
    $containerLi = $('#container li'),<br />
    $containerLiSpan = $('#container li span');

// 建议 (高效)

var<br />
    $container = $('#container '),<br />
    $containerLi = $container.find('li'),<br />
    $containerLiSpan= $containerLi.find('span');</code></pre>
<h1>避免通用选择符</h1>
<p>将通用选择符放到后代选择符中，性能非常糟糕。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$('.container &gt; *'); 

// 建议

$('.container').children();</code></pre>
<h1>避免隐式通用选择符</h1>
<p>通用选择符有时是隐式的，不容易发现。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$('.someclass :radio'); 

// 建议

$('.someclass input:radio');</code></pre>
<h1>优化选择符</h1>
<p>例如，Id选择符应该是唯一的，所以没有必要添加额外的选择符。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$('div#myid');<br />
$('div#footer a.myLink');

// 建议<br />
$('#myid');<br />
$('#footer .myLink');</code></pre>
<h1>避免多个ID选择符</h1>
<p>在此强调，ID 选择符应该是唯一的，不需要添加额外的选择符，更不需要多个后代ID选择符。</p>
<pre class="prettyprint linenums"><code>// 糟糕

$('#outer #inner'); 

// 建议

$('#inner');</code></pre>
<h1>坚持最新版本</h1>
<p>新版本通常更好：更轻量级，更高效。显然，你需要考虑你要支持的代码的兼容性。例如，2.0版本不支持ie 6/7/8。</p>
<h1>摒弃弃用方法</h1>
<p>关注每个新版本的废弃方法是非常重要的并尽量避免使用这些方法。</p>
<pre class="prettyprint linenums"><code>// 糟糕 - live 已经废弃

$('#stuff').live('click', function() {<br />
  console.log('hooray');<br />
});

// 建议<br />
$('#stuff').on('click', function() {<br />
  console.log('hooray');<br />
});<br />
// 注：此处可能不当，应为live能实现实时绑定，delegate或许更合适</code></pre>
<h1>利用CDN</h1>
<p>谷歌的CND能保证选择离用户最近的缓存并迅速响应。（使用谷歌CND请自行搜索地址，此处地址以不能使用，推荐jquery官网提供的CDN）。<br />常用前端公共库CDN服务:&nbsp;<a href="http://www.jingwentian.com/t-319" rel="external nofollow noreferrer">http://www.jingwentian.com/t-319</a></p>
<h1>必要时组合jQuery和javascript原生代码</h1>
<p>如上所述，jQuery就是javascript，这意味着用jQuery能做的事情，同样可以用原生代码来做。<br />原生代码（或 vanilla&nbsp;<a href="http://vanilla-js.com/" rel="external nofollow noreferrer">http://vanilla-js.com/</a>&nbsp;）的可读性和可维护性可能不如jQuery，而且代码更长。但也意味着更高效（通常更接近底层代码可读性越差，性能越高，例如：汇编，当然需要更强大的人才可以）。牢记没有任何框架能比原生代码更小，更轻，更高效（注：测试链接已失效，可上网搜索测试代码）。</p>
<p>鉴于vanilla 和 jQuery之间的性能差异，我强烈建议吸收两人的精华，使用（可能的话）和jQuery等价的原生代码 (&nbsp;<a href="http://www.leebrimelow.com/native-methods-jQuery/" rel="external nofollow noreferrer">http://www.leebrimelow.com/native-methods-jQuery/</a>&nbsp;)。</p>
<h1>最后忠告</h1>
<p>最后，我记录这篇文章的目的是提高jQuery的性能和其他一些好的建议。如果你想深入的研究对这个话题你会发现很多乐趣。记住，jQuery并非不可或缺，仅是一种选择。思考为什么要使用它。DOM操作？ajax？模版？css动画？还是选择符引擎？或许javascript微型框架或jQuery的定制版是更好的选择。</p>
<hr />
<h1>参考</h1>
<p>(翻译自：<a href="http://flippinawesome.org/2013/11/25/writing-better-jquery-code/" rel="external nofollow noreferrer">http://flippinawesome.org/2013/11/25/writing-better-jquery-code/</a>&nbsp;)<br /><a href="http://yanhaijing.com/jquery/2013/12/05/writing-better-jquery-code/" rel="external nofollow noreferrer">http://yanhaijing.com/jquery/2013/12/05/writing-better-jquery-code/</a><br /><a href="http://segmentfault.com/q/1010000000633373" rel="external nofollow noreferrer">http://segmentfault.com/q/1010000000633373</a></p>
<p><a href="http://ryxxlong.iteye.com/blog/622460" rel="external nofollow noreferrer">http://ryxxlong.iteye.com/blog/622460</a><br /><a href="http://blog.jobbole.com/7026/" rel="external nofollow noreferrer">http://blog.jobbole.com/7026/</a><br /><a href="http://blog.jobbole.com/10279/" rel="external nofollow noreferrer">http://blog.jobbole.com/10279/</a></p>
<hr />
<h1>给JavaScript初学者的24条最佳实践</h1>
<div>
<h2>JavaScript初学者应知的24条最佳实践</h2>
<blockquote><p>原文&nbsp;<a href="http://youngsterxyf.github.io/2013/03/11/js-best-practices-for-beginners/" rel="external nofollow noreferrer">http://youngsterxyf.github.io/2013/03/11/js-best-practices-for-beginners/</a></p></blockquote>
<p><strong>1.优先使用===，而不是==</strong></p>
<p>JavaScript使用两种相等性操作符：===|!==和==|!=。通常认为做比较的最佳实践是使用前一组操作符。</p>
<blockquote><p>"若两个操作数的类型和值相同，那么===比较的结果为真，!==比较的结果为假。" --- JavaScript语言精粹(JavaScript: The Good Parts)</p></blockquote>
<p>然而，如果使用==和!=，当比较不同类型的操作数时，你就会碰到问题啦。在这种情况下，这组操作符会尝试对操作数的值做无用的强制转换。</p>
<p><strong>2.Eval就是糟糕的代名词</strong></p>
<p>对于那些不熟悉JavaScript的人来说，函数"evel"让我们能够访问JavaScript编译器。我们可以通过给"eval"传递一个字符串参数来得到该字符串执行的结果。</p>
<p>这不仅会极大地降低你的脚本的性能，也会造成一个巨大的安全隐患，因为这赋予传递进来的纯文本太多的能力。要尽可能地避免eval函数的使用。</p>
<p><strong>3.不要懒手</strong></p>
<p>技术上来说，你确实可能侥幸地省略多数花括号和分号。大多数浏览器都能够正确地解释如下代码片段：</p>
<p><code>if(someVariableExists) x = false</code></p>
<p>然而，再考虑一下这段代码：</p>
<p><code>if(someVariableExists) x = false anotherFunctionCall();</code></p>
<p>可能会有人认为上一段代码等价于：</p>
<p><code>if(someVariableExists) { x = false; anotherFunctionCall(); }</code></p>
<p>很不幸，他错了。事实上，它的本意是：</p>
<p><code>if(someVariableExists) x = false; anotherFunctionCall();</code></p>
<p>你应该也注意到了，代码中缩进模仿了花括号的功能。毋庸置疑，这是非常恐怖的做法，无论如何都应该避免。唯一可以省略花括号的时候是在一行式的语句中，但即使这种情况，也是很有争议的。</p>
<p><code>if(2 + 2 === 4) return 'nicely done';</code></p>
<p>始终要想着以后</p>
<p>如果以后的某个时候，你需要在这种if语句中增加更多的命令，那该怎么办呢？没法子，你就只能重写这块代码了。处理这个问题的底线是对于省略写法保持谨慎。</p>
<p><strong>4.使用JS Lint</strong></p>
<p>JSLint是Douglas Crockford编写的一个调试器。简单地将你的脚本拷贝进去，它就会快速地扫描你的代码中任何明显的问题和错误。</p>
<blockquote><p>"JSLint获取一份JavaScript源码，然后扫描代码。如果发现问题，就会返回一条信息描述这个问题以及这个问题在源码中的大致位置。问题虽然经常是语法错误，却不一定是。JSLint也会查看一些风格习惯以及结构问题。它并不证明你的代码是否正确，只是提供另外的一双眼睛来帮助发现问题。"---JSLint文档</p></blockquote>
<p>在结束脚本代码的编写之前，对其执行一次JSLint，能够保证你不会犯一些愚蠢的错误。</p>
<p><strong>5.将脚本置于页面的底部</strong>&nbsp;这条技巧在本系列前面的文章中也推荐过。因为它在此处也非常合适（As it's highly appropriate though），所有我将那段信息直接粘贴在这里。</p>
<p>![javascriptButton.png](http://youngsterxyf.github.io/assets/uploads/pics/javascriptButton.png "enter image title here")</p>
<p>记住---这条最佳实践的主要目标是尽可能快速地为用户加载页面。当加载一个脚本时，浏览器直到整个脚本文件全部加载完毕才能继续。因此，用户必须等上更长的时间才能注意到任何的进度。</p>
<p>如果JS文件的目的仅仅是增加功能---例如，在点击某个按钮后---那么就将那些文件放在底部，body结束标签之前吧。这绝对是一个最佳实践。</p>
<p>更好的做法</p>
<p>```</p>
<p>And now you know my favorite kinds of corn.</p>
<p>```</p>
<p><strong>6.在For语句之外声明变量</strong></p>
<p>当执行一个冗长的"for"语句之时，仅仅让解释引擎做必须干的活吧。例如：</p>
<p>糟糕的做法</p>
<p><code>for(var i = 0; i &lt; someArray.length; i++) { var container = document.getElementById('container'); container.innerHtml += 'my number: ' + i; console.log(i); }</code></p>
<p>注意上面代码片段中的每次迭代都需要检查数组的长度，并且每次都要遍历DOM树找到"container"元素---效率多低啊！</p>
<p>更好的做法</p>
<p><code>var container = document.getElementById('container'); for(var i = 0, len = someArray.length; i &lt; len; i++) { container.innerHtml += 'my number: ' + i; console.log(i); }</code></p>
<p>感谢有位朋友留下评论展示如何进一步优化上面的代码块。</p>
<p><strong>7.构建字符串的最快方式</strong></p>
<p>当需要遍历一个数组或者对象之时，不要总是使用你能信手粘来的"for"语句。创造性地找个能够完成工作的最快速的方案。</p>
<p><code>var arr = ['item 1', 'item 2', 'item 3', ...]; var list = '&lt;ul&gt;&lt;li&gt;' + arr.join('&lt;/li&gt;&lt;li&gt;') + '&lt;/li&gt;&lt;/ul&gt;';</code></p>
<blockquote><p>"我不会以测试基准来烦你；你只须相信我（或者自己去测试一下）---这是目前为止最快的方式！"</p></blockquote>
<p>使用原生方法（比如join()），不用管抽象层面背后发生了什么，通常会比任何非原生方法快得多。 --- James Padolsey, james.padolsey.com"</p>
<p><strong>8.减少全局变量</strong></p>
<blockquote><p>"通过将全局的东西封装进单个命名空间，能够大大降低与其他应用、部件、代码库交互混乱的概率。"--- Douglas Crockford</p></blockquote>
<p>``` var name = 'jeffrey'; var lastname = 'Way';</p>
<p>function doSomething() {...}</p>
<p>console.log(name); // Jeffrey -- or window.name ```</p>
<p>更好的做法</p>
<p><code>var DudeNameSpace = { name: 'Jeffrey', lastname: 'Way', doSometing: function() {...} } console.log(DudeNameSpace.name); // Jeffrey</code></p>
<p>注意我们是怎样将全局性的&ldquo;足迹&rdquo;减少为一个命名可笑的"DudeNameSpace"对象的。</p>
<p><strong>9.注释你的代码</strong></p>
<p>一开始看起来似乎没有必要，但请相信我，你将会想尽可能好地注释你的代码。当你几个月后再次回到项目，会发生什么呢？发现你根本没法轻松地记起当初对每一行代码的想法。或者，如果你的某个同事需要修改你的代码，那又会怎么样呢？始终，一直记着注释你代码的重要部分吧。</p>
<p><code>// Cycle through array and echo out each name for(var i = 0, len = array.length; i &lt; len; i++) { console.log(array[i]); }</code></p>
<p><strong>10.拥抱渐进增强</strong></p>
<p>始终考虑到如何处理JavaScript禁用的情况。也许你会想&ldquo;大多数我网页的阅读器都是启用JavaScript的，因此我不担心这个问题。&rdquo;然而，这会是一个巨大的错误。</p>
<p>你曾花时间去看过关闭JavaScript后你的漂亮的滑动条是什么样么？（下载Web开发者工具栏以方便干这事。）也许它会完全破坏你的站点。按照以往经验，设计你的站点时应假设将会禁用JavaScript。那么，一旦你这样做了，那么开始渐进地增强你的网页布局吧！</p>
<p><strong>11.不要传递字符串给"SetInterval"或"SetTimeOut"</strong></p>
<p>考虑一下如下代码：</p>
<p><code>setInterval( "document.getElementById('container').innerHTML += 'my new number: ' + i", 3000 );</code></p>
<p>这段代码不仅低效，而且其行为与"eval"函数相同。永远不要传给字符串给SetInterval和SetTimeOut。相反，应传递一个函数名。</p>
<p><code>setInterval(someFunction, 3000);</code></p>
<p><strong>12.不要使用"With"语句</strong>&nbsp;乍一看，"With"语句似乎是个聪明的想法。基本概念是它们能够为访问深度嵌套对象提供一种简写方式。例如...</p>
<p><code>with (being.person.man.bodyparts) { arms = true; legs = true; }</code></p>
<p>取代如下写法</p>
<p><code>being.person.man.bodyparts.arms = true; being.person.man.bodyparts.legs = true;</code></p>
<p>很不幸，经过一些测试，会发现这种简写在设置新成员时表现非常糟糕。作为替代，你应该使用var。</p>
<p><code>var o = being.person.man.bodyparts; o.arms = true; o.legs = true;</code></p>
<p><strong>13.使用{}而不是New Object()</strong></p>
<p>JavaScript中有多种创建对象的方式。也许更传统的方式是使用"new"构造器，像这样：</p>
<p><code>var o = new Object(); o.name = 'Jeffrey'; o.lastname = 'Way'; o.someFuncion = function() { console.log(this.name); }</code></p>
<p>然而，这种方式因其行为并不是我们所想的那样而被认为是&ldquo;糟糕的实践。相反，我推荐你使用更健壮的对象字面方法。</p>
<p>更好的写法</p>
<p><code>var o = { name: 'Jeffrey', lastName: 'Way', someFunction: function() { console.log(this.name); } };</code></p>
<p>注意如果你只是想简单地创建个空对象，{}就派上用场了。</p>
<p><code>var o = {};</code></p>
<blockquote><p>"对象字面量使我们能够编写支持很多特性的代码，并对代码的实现者来说代码仍然相对直观。不需要直接调用构造器或维护传递给函数的参数的正确顺序，等等。" --- dyn-web.com</p></blockquote>
<p><strong>14.使用[]而不是New Array()</strong></p>
<p>这同样适用于创建一个新数组。</p>
<p>过得去的写法</p>
<p><code>var a = new Array(); a[0] = 'Joe'; a[1] = 'Plumber';</code></p>
<p>更好的写法</p>
<p><code>var a = ['Joe', 'Plumber'];</code></p>
<blockquote><p>"JavaScript中一个常见的错误是需要数组时使用对象或需要对象时使用数组。规则很简单：当属性名是小的连续整数时，你应该使用数组。否则，使用对象"---Douglas Crockford</p></blockquote>
<p><strong>15.一长串变量？省略"var"关键字，使用逗号替代</strong></p>
<p><code>var someItem = 'some string'; var anotherItem = 'another string'; var oneMoreItem = 'one more string';</code></p>
<p>更好的写法</p>
<p><code>var someItem = 'some string', anotherItem = 'another string', oneMoreItem = 'one more string';</code></p>
<p>相当的不言自明。我不知道这里是否有任何真正的速度提升，但是它使你的代码更加简洁了。</p>
<p><strong>16.始终，始终使用分号</strong></p>
<p>技术上来说，大多数浏览器都允许你的省略一些分号。</p>
<p><code>var someItem = 'some string' function doSomething() { return 'something' }</code></p>
<p>话虽如此，但这是一种非常糟糕的做法，可能导致更大的问题，问题查找起来也更困难。</p>
<p>更好的写法</p>
<p><code>var someItem = 'some string'; function doSomething() { return 'something'; }</code></p>
<p><strong>18."For in"语句</strong></p>
<p>遍历对象内的成员时，你也会得到方法函数。为了解决这个问题，应始终将你的代码包装在一个if语句中来过滤信息。</p>
<p><code>for(key in object) { if(object.hasOwnProperty(key)) { ... then do something... } }</code></p>
<p>引自JavaScript: 语言精粹， Douglas Crockford著</p>
<p><strong>19.使用Firebug的"Timer"特性来优化代码</strong></p>
<p>需要一种快速简单的方法来检测一个操作花费多长时间么？使用Firebug的"timer"特性记录结果。</p>
<p><code>function TimeTracker() { console.time("MyTimer"); for(x=5000; x &gt; 0; x--){} console.timeEnd("MyTimer"); }</code></p>
<p><strong>20.阅读，阅读，再阅读</strong></p>
<p>我是一个Web开发博客的超级粉丝（比如这个博客！），但吃午餐或者睡前，博客确实不是书籍的替代品。始终在你的床前桌上放一本wen开发书籍吧。如下是一些我最喜欢的JavaScript书籍。</p>
<p><a href="http://www.packtpub.com/object-oriented-javascript-applications-libraries/book" rel="external nofollow noreferrer">面向对象的JavaScript</a>&nbsp;<a href="http://oreilly.com/catalog/9780596517748/" rel="external nofollow noreferrer">JavaScript：语言精粹</a>&nbsp;<a href="http://www.packtpub.com/learning-jquery-1.3/book" rel="external nofollow noreferrer">学习jQuery 1.3</a>&nbsp;<a href="http://oreilly.com/catalog/9780596527464/" rel="external nofollow noreferrer">学习JavaScript</a></p>
<p>多阅读几遍。我仍旧在读！</p>
<p><strong>21.自执行函数(Self-Executing Functions)</strong></p>
<p>相比调用函数，当页面加载或调用父函数时，让函数自动执行会简单些。简单地将你的函数包装在圆括号内，并添加额外的一对圆括号，其本质上就调用了这个函数。</p>
<p><code>(function doSomething() { return { name: 'jeff', lastName: 'way' }; })();</code></p>
<p><strong>22.原始(raw)JavaScript代码的执行速度始终快于使用代码库</strong></p>
<p>JavaScript代码库，如jQuery和Mootools，能够为你节省大量的编码时间---特别是使用AJAX操作。话虽如此，始终谨记代码库的执行速度始终是比不上原始JavaScript代码的（假设了代码的正确性）。</p>
<p>jQuery的"each"方法用来做遍历非常赞，但使用原生"for"语句始终会快一些。</p>
<p><strong>23.Crockford的JSON.Parse</strong></p>
<p>虽然JavaScript 2应该有一个内置的JSON解析器，但写本文之时，我们仍旧需要自己实现。Douglas Crockford，JSON的创造者，已经实现了一个解析器供你使用。可以从<a href="https://github.com/douglascrockford/JSON-js" rel="external nofollow noreferrer">这里下载</a>。</p>
<p>简单地导入该脚本，你就能获得一个新的JSON全局对象，用于解析你的.json文件。</p>
<p>``` var response = JSON.parse(xhr.responseText);</p>
<p>var container = document.getElementById('container'); for(var i = 0, len = response.length; i &lt; len; i++) { container.innerHTML += '</p>
<ul><li>' + response[i].name + ' : ' + response[i].email + '</li></ul>
<p>'; } ```</p>
<p><strong>24.删除"Language"</strong></p>
<p>几年前，在script标签内常见有"language"属性。</p>
<p>```</p>
<p>```</p>
<p>然而，这个属性很早就被弃用了，所以就不要再使用了。</p>
<p><strong>就这些了，同志们</strong></p>
<p>现在你知道这JavaScript初学者应该知道的24条基本技巧。有机会也让我知道一下你的小贴士吧。感谢阅读。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r13mr8.html">64位系统里的IIS运行32位ODP&period;NET的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9640448.html">DOM样式操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k4kj59.html">Leetcode &num; 169&comma; 229 Majority Element I and II</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnpeox8.html">SQLAlchemy 做migration的时候 ValueError&colon; too many values to unpack</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11nek9.html">关于职位的解释---转CSDN的文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p7l39.html">Linux驱动设计&mdash;&mdash;阻塞和同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z166jx9.html">C&num;&mdash;&mdash;字符操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmdze09.html">&lbrack;BZOJ 1029&rsqb; &lbrack;JSOI2007&rsqb; 建筑抢修 【贪心】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1nlp19.html">&lbrack;分享&rsqb;WPF 虚拟键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/90von4m8.html">REST Web Server&comma;REST介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mp2lxq.html">《JavaScript&plus;DOM编程艺术》的摘要（一）---基本知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjj77l8.html">ASP&period;NET MVC&plus;EF框架&plus;EasyUI实现权限管理系列&lpar;3&rpar;-面向接口的编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwx6jq.html">Mysql 嵌套游标添以及任意位置声明变量的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj0pzl8.html">css删除线，下划线等</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljk5pk9.html">C&num;文件下载（适用于各个浏览器）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j425v8.html">elasticsearch6&period;x集群环境部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wx4g0q.html">vivado源文件和仿真文件的建立</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvlwer8.html">Json&period;net日期格式化设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pr71q.html">SessionFactory 执行原生态的SQL语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvz2v28.html">workerman 7272端口被占用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8opj2lq.html">Html和CSS的关系</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k6jj6q.html">grep -i 不区分大小写</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j6m6wq.html">Gradle使用指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd1j70q.html">Pyqt QSS简单的Ui美化</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd153vq.html">poj 1007&colon;DNA Sorting（水题，字符串逆序数排序）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxjl009.html">ArcGIS图层和要素的过滤显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq45m609.html">php开发（TP框架使用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2e0rxq.html">ASP&period;NET 5探险（5）：利用AzureAD实现单点登录</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p63pdq.html">为什么没有选择sipml5</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxj5gz9.html">C&plus;&plus; find 函数用法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
